
  var app = angular
  .module("MyApp", ["ngRoute", "ui.materialize", "ngMask", "ngCordova"])

  .config( function($routeProvider, $locationProvider, $cordovaAppRateProvider, $cordovaInAppBrowserProvider) {
            var browserOptions = {
              location: "yes",
              toolbar: "yes"
            };
            document.addEventListener("deviceready", function () {
              var preferences = {
                iosURL: "some URL",
                appName: 'APP NAME',
                language: 'fr'
              };
              $cordovaAppRateProvider.setPreferences(preferences);
            }, false);
            $cordovaInAppBrowserProvider.setDefaultOptions(browserOptions);

  // .config( function($routeProvider, $locationProvider) {
    $routeProvider
      
      .when("/login", {
        templateUrl : "view/login.html"
      })
      .when("/operation/:were_id", {
        templateUrl : "view/operation.html",
        controller: 'operationCtrl'
      })
      .when("/transfer/:were_id", {
        templateUrl : "view/transfer_operation.html",
        controller: 'transferoperationCtrl'
      })
      .when("/home", {
        templateUrl : "view/home.html"
      })
      .when("/incoming/:were_id", {
        templateUrl : "view/incoming.html",
        controller: 'IncomingCtrl'
      })
      .when("/incoming_item/:were_id/:qr_id", {
        templateUrl : "view/incoming_item.html",
        controller: 'IncomingItemCtrl'
      })
      .when("/info/:were_id", {
        templateUrl : "view/info.html",
        controller: 'InfoCtrl'
      })
      .when("/outgoing_item/:were_id/:out_id/:qr_id", {
        templateUrl : "view/outgoing_item.html",
        controller: 'OutgoingItemCtrl'
      })
      .when("/outgoing/:were_id/:out_id", {
        templateUrl : "view/outgoing.html",
        controller: 'OutgoingCtrl'
      })
      .when("/outgoing_job_list/:were_id", {
        templateUrl : "view/outgoing_job_list.html",
        controller: 'OutgoingJobCtrl'
      })
      .when("/ship/:were_id", {
        templateUrl : "view/ship.html",
        controller: 'ShipCtrl'
      })
      .when("/transfer_external/:were_id", {
        templateUrl : "view/transfer_external.html",
        controller: 'TransferExternalCtrl'
      })
      .when("/transfer_internal/:were_id", {
        templateUrl : "view/transfer_out_list.html",
        controller: 'TransferOutJobCtrl'
      })
      .when("/transfer_out/:were_id/:trans_id", {
        templateUrl : "view/transfer_out.html",
        controller: 'TransferOutCtrl'
      })
      .when("/transfer_external_out/:were_id/:trans_id", {
        templateUrl : "view/transfer_external_out.html",
        controller: 'TransferExternalOutCtrl'
      })
      .when("/transfer_external_in/:were_id/:trans_id", {
        templateUrl : "view/transfer_external_in.html",
        controller: 'TransferExternalInCtrl'
      })
      .when("/transfer_job_list/:were_id", {
        templateUrl : "view/transfer_job_list.html",
        controller: 'TransferJobCtrl'
      })
      .when("/transfer_in/:were_id/:trans_id", {
        templateUrl : "view/transfer_in.html",
        controller: 'TransferInCtrl'
      })
      .otherwise({
        redirectTo: '/login'
      });
  })
/*
  .run(function ($rootScope, $location, $route, $http, $timeout, $ionicPlatform, $cordovaNetwork, $cordovaBatteryStatus, $cordovaLocalNotification, $cordovaPush) {
        $ionicPlatform.ready(function () {
          $rootScope.$on("$cordovaNetwork:offline", function (event, result) {
            alert("Device is now Offline!");
          });
          $rootScope.$on("$cordovaNetwork:online", function (event, result) {
            alert("Device is Online!");
          });
        })
*/
  .run(function ($rootScope, $location, $route, $http, $timeout) {
        $rootScope.$on("$routeChangeStart", function (event, next, current) {
            $rootScope.authenticated = false;
            $http.get('https://wms-lite.website/function/check_login.php').success(function (results) {
                if (results.uid) {
                  $rootScope.authenticated = true;
                  $rootScope.uid = results.uid;
                  $rootScope.wms_profile_id = results.wms_profile_id;
                  $rootScope.wms_user_id = results.wms_user_id;
                  $rootScope.wms_user_login = results.wms_user_login;
                  $rootScope.wms_user_password = results.wms_user_password;
                  $rootScope.wms_user_type = results.wms_user_type;
                  $rootScope.wms_user_name = results.wms_user_name;
                  $rootScope.wms_user_time_zone = results.wms_user_time_zone;
                  $rootScope.wms_permition = results.wms_permition;
                } else {
                  var nextUrl = next.$$route.originalPath;
                  if (nextUrl == '/login' || 
             		      nextUrl == '/product_detail/:orderId') {		
					   
                  } else {
                      $location.path("/login");
                  }
                }
            });
          
        }); 
    var history = [];

    $rootScope.$on('$routeChangeSuccess', function() {
        history.push($location.$$path);
    });

    $rootScope.back = function () {
        var prevUrl = history.length > 1 ? history.splice(-2)[0] : "/";
        $location.path(prevUrl);
        $rootScope.preload('reload');
		//Materialize.toast("Back", 500);
    };
    $rootScope.refresh = function () {
        $route.reload();
        $rootScope.preload('reload');
    //Materialize.toast("Refresh", 500);
    };
      var cdtimer;
      var cdpreload=function(){
        cdtimer=$timeout(function(){
          if($rootScope.vispreload == "reload"){
            $rootScope.vispreload = 'network';
          }
        },25000);
      }; 
    $rootScope.startTimeout = function () { 
        cdpreload();
    }  
    $rootScope.stopTimeout = function () {  
        $timeout.cancel(cdtimer);  
    }  
    $rootScope.preload = function (type) {
      $rootScope.vispreload = type;
      if(type == "reload"){
         $rootScope.startTimeout();
      }else{  
         $rootScope.stopTimeout();
      }
    };
    $rootScope.preload('reload');
  })
  .filter('cut', function () {
        return function (value, wordwise, max, tail) {
            if (!value) return '';

            max = parseInt(max, 10);
            if (!max) return value;
            if (value.length <= max) return value;

            value = value.substr(0, max);
            if (wordwise) {
                var lastspace = value.lastIndexOf(' ');
                if (lastspace != -1) {
                  //Also remove . and , so its gives a cleaner result.
                  if (value.charAt(lastspace-1) == '.' || value.charAt(lastspace-1) == ',') {
                    lastspace = lastspace - 1;
                  }
                  value = value.substr(0, lastspace);
                }
            }

            return value + (tail || ' …');
        };	
  })
  .filter('unsafe', function($sce) {
    return function(val) {
        return $sce.trustAsHtml(val);
    };
  })
  .directive('imageonload', function() {
    return {
        restrict: 'A',
        link: function($scope, element, attrs) {
            element.bind('load', function() {
				$scope.$apply(function() {
					$scope.visible = true;
				});
            });
            element.bind('error', function(){
                //alert('image could not be loaded');
            });
        }
    };
  })
  .directive('icOnly', function () {
    return {
        require: 'ngModel',
        link: function (scope, element, attr, ngModelCtrl) {
            function fromUser(text) {
                if (text) {
                    var transformedInput = text.replace(/[^0-9^\d-]/g, '');

                    if (transformedInput !== text) {
                        ngModelCtrl.$setViewValue(transformedInput);
                        ngModelCtrl.$render();
                    }
                    return transformedInput;
                }
                return undefined;
            }            
            ngModelCtrl.$parsers.push(fromUser);
        }
    };
  })
  .directive('numbersOnly', function () {
    return {
        require: 'ngModel',
        link: function (scope, element, attr, ngModelCtrl) {
            function fromUser(text) {
                if (text) {
                    var transformedInput = text.replace(/[^0-9]/g, '');

                    if (transformedInput !== text) {
                        ngModelCtrl.$setViewValue(transformedInput);
                        ngModelCtrl.$render();
                    }
                    return transformedInput;
                }
                return undefined;
            }            
            ngModelCtrl.$parsers.push(fromUser);
        }
    };
  })
  .controller('InputController', function (){
    $('select').material_select();
    $('.datepicker').pickadate({
        selectMonths: true, // Creates a dropdown to control month
        selectYears: 30 // Creates a dropdown of 15 years to control year
    });
    $('.materialboxed').materialbox();
  })
   //##########################################################################//
   //###############          Start MainControl        		           ##########//
   //##########################################################################//
  .controller("mainController", ["$scope", "$routeParams", "$location", "$route", "$http", "$rootScope", "$timeout", function($scope, $routeParams, $location, $route, $http, $rootScope, $timeout){
    $rootScope.var_back = {
        route: "",
        name: ""
    };

    $scope.model = {
      chips: ["Item1", "Item2"],
      site: {
        phone: "+49174406053684",
        email: ""
      },
      set_sidebar: [
         {  
        "name": "Home",
        "route": "home",
        "img": "R-Home.png",
      },{
        "name": "Login",
        "route": "login",
        "img": "R-Login.png",
      },{
        "name": "Archive",
        "route": "archive",
        "img": "R-Archive.png",
         }
      ],
      set_logout: [
         {  
        "name": "Home", 
        "route": "home",
        "img": "R-Home.png",
      },{
        "name": "My Account",
        "type": "gourl", 
        "route": "account",
        "img": "R-My-Acc.png",
      },{
        "name": "Feedback", 
        "route": "feedback",
        "img": "R-Feedback.png",
      },{
        "name": "Archive",
        "route": "archive",
        "img": "R-Archive.png",
      },{
        "name": "Logout",
        "route": "logout",
        "img": "R-Login.png",
         }
      ]
    };
	  
    
     // Share button
     $scope.openmodel = function(add) { 
      $('#modal1').modal('open'); 
     };
     // Share button
     $scope.ShareProduct = function(img, title, hreflink) { 
       window.plugins.socialsharing.share('', title, img, hreflink); 
     };
    $scope.goToSite = function(site, $event) {
		
      if(site == "logout"){
          $rootScope.authenticated = false;
          $rootScope.uid = "";
          $rootScope.wms_profile_id =   "";
          $rootScope.wms_user_id = "";
          $rootScope.wms_user_login = "";
          $rootScope.wms_user_password = "";
          $rootScope.wms_user_type = "";
          $rootScope.wms_user_name = "";
          $rootScope.wms_user_time_zone = "";
          $rootScope.wms_permition = "";

          $http.get('https://wms-lite.website/function/logout.php').success(function(data) {
            $location.path('login');
            $('.button-collapse').sideNav('hide');
          });
        }else if(site == "feedback"){
          window.location.href = 'mailto:enquiry@publicgold.com.my?Subject=Feedback';
        }else{
          $location.path(site);
          $rootScope.preload('reload');
          $('.button-collapse').sideNav('hide');
      }
    };
  }])
   //##########################################################################//
   //###############          End MainControl      			             ##########//
   //##########################################################################//
   //###############          Start LoginCtrl                        ##########//
   //##########################################################################//
   .controller("LoginCtrl", ["$scope", "$routeParams", "$location", "$route", "$http", "$rootScope", "$timeout", function($scope, $routeParams, $location, $route, $http, $rootScope, $timeout){
    $rootScope.var_back = {
        route: "",
        name: ""
    };
    $rootScope.preload('no');


    // var local_name = localStorage.getItem('username');
    // var local_pass = localStorage.getItem('password');
    // localStorage.setItem('registrationId', data.registrationId);

    var rm_name = localStorage.getItem('rmusername');    
    var rm_pass = "";    
    if(rm_name){   
    var rm_remember = true;  
    }else{
    var rm_remember = false;  
    }
    $scope.newLogin = {
        username: rm_name,
        //password: ""
        password: rm_pass,
        remember: rm_remember
    };
    $scope.LoginClick = function() {
       $http.post("https://wms-lite.website/function/login.php",{'username': $scope.newLogin.username, 'password': $scope.newLogin.password}).success(function(data, status, headers, config){
       //$http.post("https://wms-lite.website/function/login.php",{'username': 'testzack', 'password': 'testzack'}).success(function(data, status, headers, config){
		
		      if (data.status == "ok") {
            if($scope.newLogin.remember == true){
              localStorage.setItem('rmusername', $scope.newLogin.username);
            }else{
              localStorage.setItem('rmusername', "");
            }
            Materialize.toast(data.message, 4000);
            $location.path('home');
         }else{
		        Materialize.toast(data.message, 4000);
         }
	   });

     };	 
  }])
   //##########################################################################//
   //###############          End LoginCtrl			                     ##########//
   //##########################################################################//
   //###############          Start homeCtrl                         ##########//
   //##########################################################################//
   .controller("homeCtrl", ["$scope", "$routeParams", "$location", "$route", "$http", "$rootScope", "$timeout", function($scope, $routeParams, $location, $route, $http, $rootScope, $timeout){
    $rootScope.var_back = {
        route: "logout",
        name: "Logout"
    };
	   $http.get('https://wms-lite.website/function/home.php').success(function(data) {
        if (data.status == "ok") {
          $scope.warehouse = data;
            if(data.num > 1){
				
      			}else{
      				$location.path("operation/zero");
      			}
          $rootScope.preload('no');
        }else{
          Materialize.toast("Network Error", 4000);
        }
     });
	   
	   
  }])
   //##########################################################################//
   //###############          End homeCtrl                           ##########//
   //##########################################################################//
   //###############          Start IncomingCtrl                     ##########//
   //##########################################################################//
 .controller("IncomingCtrl", ["$scope", "$routeParams", "$location", "$route", "$http", "$rootScope", "$timeout", "$cordovaBarcodeScanner", "$cordovaDialogs", function($scope, $routeParams, $location, $route, $http, $rootScope, $timeout, $cordovaBarcodeScanner, $cordovaDialogs){
    $rootScope.var_back = {
        route: "operation/"+$routeParams.were_id,
        name: "Operation"
    };
    $scope.iscpreload = 'no';
    $rootScope.preload('no');
    $http.post("https://wms-lite.website/function/incoming_list_item.php",{'were': $routeParams.were_id}).success(function(data, status, headers, config){
        if (data.status == "ok") {
          $scope.incoming_data = data;
          $rootScope.preload('no');
        }else{
          Materialize.toast("Network Error", 4000);
        }
    });
  // scanbarcode(rowincoming_data.qr_id);
    $scope.scanbarcode = function(qr_id, trxn_barcode, prod_barcode_scan) {
        if(trxn_barcode == 1 || prod_barcode_scan == 1){
          $location.path("/incoming_item/"+$routeParams.were_id+"/"+qr_id);
        }
    }
  //scan item
    $scope.scan = function () {
      $scope.iscpreload = 'reload';
      $cordovaBarcodeScanner
        .scan()
        .then(function (result) {
          $timeout(function(){
            $scope.scanResult = result;
            if(result.cancelled == 1 || result.cancelled == true){
                $route.reload();
                $rootScope.preload('no');
            }else{
              $http.post("https://wms-lite.website/function/incoming_check_item.php",{'were_id': result.text, 'were': $routeParams.were_id}).success(function(data, status, headers, config){
           
                   if (data.status == "ok") {
                     Materialize.toast(data.message, 4000);
                     $scope.scan();
                   }else{
                     Materialize.toast(data.message, 4000);
                     $route.reload();
                     $rootScope.preload('no');
                   }
              });  
            }
          },1000);
        }, function (err) {
          $scope.scanResult = 'SCAN ERROR (see console)';
          // console.error(err);
        },
    {
      preferFrontCamera : true,
            showFlipCameraButton : true,
            formats : "QR_CODE, RSS_EXPANDED",
            prompt: "Place a barcode inside the scan area",    //if I remove this line, the prompt shows the result the same way
            orientation : "portrait"
  }
    
    );
    };
  
  
  //stall location
    $scope.scanloc = function () {
      $scope.iscpreload = 'reload';
      $cordovaBarcodeScanner
        .scan()
        .then(function (result) {
          $timeout(function(){
            $scope.scanResult = result;
            if(result.cancelled == 1 || result.cancelled == true){

            }else{
              $rootScope.preload('no');
              $http.post("https://wms-lite.website/function/incoming_check_loc.php",{'loc_id': result.text, 'were': $routeParams.were_id}).success(function(data, status, headers, config){
                   if (data.status == "ok") {

                    $scope.action = "Confirm";
                    $cordovaDialogs.confirm('Are you sure?', "Stock in").then(function (buttonIndex) {
                      if(buttonIndex == 1){
                         $http.post("https://wms-lite.website/function/incoming_save_item.php",{'were': $routeParams.were_id}).success(function(data, status, headers, config){
                             if (data.status == "ok") {
                               Materialize.toast(data.message, 4000);
                               $route.reload();
                             }else{
                               Materialize.toast("Network Error", 4000);
                             }
                         });
                      }else{
                         Materialize.toast("Stock Cancelled", 4000);
                         $route.reload();
                      }
                    });
                   }else{
                     Materialize.toast(data.message, 4000);
                     $route.reload();
                   }
              });
            }
          },1000);
        }, function (err) {
          $scope.scanResult = 'SCAN ERROR (see console)';
          // console.error(err);
        });
    };

    $scope.ChangeQty = function(qr_id, packing_qty, process_qty) {
        $http.post("https://wms-lite.website/function/incoming_change_item.php",{'qr_id': qr_id, 'packing_qty': packing_qty, 'process_qty': process_qty, 'were': $routeParams.were_id}).success(function(data, status, headers, config){
             if (data.status == "ok") {
              //$route.reload();
               Materialize.toast(data.message, 4000);
             }else{
               $route.reload();
               Materialize.toast(data.message, 4000);
             }
        });
    }
    $scope.DeleteQty = function (qr_id) {
      $http.post("https://wms-lite.website/function/incoming_delete_item.php",{'qr_id': qr_id}).success(function(data, status, headers, config){
           if (data.status == "ok") {
              $route.reload();
           }else{
             Materialize.toast("Network error", 4000);
           }
      });
    }


  }])
 .controller("IncomingItemCtrl", ["$scope", "$routeParams", "$location", "$route", "$http", "$rootScope", "$timeout", "$cordovaBarcodeScanner", "$cordovaDialogs", function($scope, $routeParams, $location, $route, $http, $rootScope, $timeout, $cordovaBarcodeScanner, $cordovaDialogs){
    $rootScope.var_back = {
        route: "incoming/"+$routeParams.were_id,
        name: "Incoming"
    };
    $scope.iscpreload = 'no';
    $rootScope.preload('no');
    $http.post("https://wms-lite.website/function/incoming_barcode.php",{'were': $routeParams.were_id, 'qr_id': $routeParams.qr_id}).success(function(data, status, headers, config){
        if (data.status == "ok") {
          $scope.incoming_data = data;
          $rootScope.preload('no');
        }else{
          Materialize.toast("Network Error", 4000);
        }
    });

    //scan item
    $scope.scan = function () {
    $scope.iscpreload = 'reload';
    $cordovaBarcodeScanner
      .scan()
      .then(function (result) {
        $timeout(function(){
          $scope.scanResult = result;
          if(result.cancelled == 1 || result.cancelled == true){
            $route.reload();
            $rootScope.preload('no');
          }else{
            $http.post("https://wms-lite.website/function/incoming_barcode_check.php",{'barcode_no': result.text, 'qr_id': $routeParams.qr_id, 'were': $routeParams.were_id}).success(function(data, status, headers, config){
              if (data.status == "ok") {
                Materialize.toast(data.message, 4000);
                $scope.scan();
              }else{
                Materialize.toast(data.message, 4000);
                $route.reload();
                $rootScope.preload('no');
              }
            });  
          }
        },1000);
      }, function (err) {
        $scope.scanResult = 'SCAN ERROR (see console)';
        // console.error(err);
      },{
        preferFrontCamera : true,
        showFlipCameraButton : true,
        formats : "QR_CODE, RSS_EXPANDED",
        prompt: "Place a barcode inside the scan area",    //if I remove this line, the prompt shows the result the same way
        orientation : "portrait"
      }
      );
    };
    $scope.scan_keyin = function () {
        $scope.action = "Confirm";
        $cordovaDialogs.prompt('Please enter your barcode.', "Stock in").then(function (result) {
          if(result.buttonIndex == 1){
            $http.post("https://wms-lite.website/function/incoming_barcode_check.php",{'barcode_no': result.input1, 'qr_id': $routeParams.qr_id, 'were': $routeParams.were_id}).success(function(data, status, headers, config){
              if (data.status == "ok") {
                Materialize.toast(data.message, 4000);
                $scope.scan_keyin();
              }else{
                Materialize.toast(data.message, 4000);
                $route.reload();
                $rootScope.preload('no');
              }
            }); 
          }else{
             Materialize.toast("Barcode enter Cancelled", 4000);
             $route.reload();
             $rootScope.preload('no');             
          }
        });
    };

    $scope.DeleteQty = function (barcode_id) {
      $http.post("https://wms-lite.website/function/incoming_barcode_delete.php",{'barcode_id': barcode_id}).success(function(data, status, headers, config){
           if (data.status == "ok") {
              $route.reload();
              Materialize.toast(data.message, 4000);
           }else{
             Materialize.toast("Network error", 4000);
           }
      });
    }


  }])
   //##########################################################################//
   //###############          End IncomingCtrl                       ##########//
   //##########################################################################//
   //###############          Start OutgoingCtrl                     ##########//
   //##########################################################################//
  .controller("OutgoingJobCtrl", ["$scope", "$routeParams", "$location", "$route", "$http", "$rootScope", "$timeout", "$cordovaDialogs", function($scope, $routeParams, $location, $route, $http, $rootScope, $timeout, $cordovaDialogs){
    $rootScope.var_back = {
        route: "operation/"+$routeParams.were_id,
        name: "Operation"
    };
    $scope.wereid = $routeParams.were_id;
    $scope.oscpreload = 'no';
    $rootScope.preload('no');
    $http.post("https://wms-lite.website/function/outgoing_job_list.php",{'were': $routeParams.were_id}).success(function(data, status, headers, config){
        if (data.status == "ok") {
         $scope.outgoing_job_date = data;
         $rootScope.preload('no');
        }else{
          Materialize.toast("Network Error", 4000);
        }
    });

  // scanbarcode(rowincoming_data.qr_id);
    $scope.go_to_job = function(link_url, old_record) {
      if(old_record == "true"){
        $scope.action = "Confirm";
        $cordovaDialogs.confirm('Do you want to take over this job?', "Stock Out").then(function (buttonIndex) {
          if(buttonIndex == 1){
            $location.path(link_url);
          }else{
            // $route.reload();
          }
        });
      }else{
          $location.path(link_url);
      }
    }

 }])
 .controller("OutgoingCtrl", ["$scope", "$routeParams", "$location", "$route", "$http", "$rootScope", "$timeout", "$cordovaBarcodeScanner", "$cordovaDialogs", function($scope, $routeParams, $location, $route, $http, $rootScope, $timeout, $cordovaBarcodeScanner, $cordovaDialogs){
    $rootScope.var_back = {
        route: "operation/"+$routeParams.were_id,
        name: "Operation"
    };
     $scope.ware = {
        were_id: $routeParams.were_id
    };
    //$routeParams.out_id
    $scope.oscpreload = 'no';
    $rootScope.preload('no');
    $http.post("https://wms-lite.website/function/outgoing_list_item.php",{'were': $routeParams.were_id, 'out_id': $routeParams.out_id}).success(function(data, status, headers, config){
        if (data.status == "ok") {
          $scope.outgoing_data = data;
          $rootScope.preload('no');
        }else{
          Materialize.toast("Network Error", 4000);
        }
    });
  // scanbarcode(rowincoming_data.qr_id);
    $scope.scanbarcode = function(qr_id, num_barcode) {
        if(num_barcode > 0){
          $location.path("/outgoing_item/"+$routeParams.were_id+"/"+$routeParams.out_id+"/"+qr_id);
        }
    }
    $scope.scan = function (old_record) {
      if(old_record == "yes"){
        $scope.action = "Confirm";
        $cordovaDialogs.confirm('Do you want to take over this job?', "Stock Out").then(function (buttonIndex) {
          if(buttonIndex == 1){
            $scope.oscpreload = 'reload';
            $cordovaBarcodeScanner
              .scan()
              .then(function (result) {
                $timeout(function(){
                  $scope.scanResult = result;
                  if(result.cancelled == 1 || result.cancelled == true){
                      $route.reload();
                      $rootScope.preload('no');
                  }else{
                    $http.post("https://wms-lite.website/function/outgoing_check_item.php",{'were_id': result.text, 'were': $routeParams.were_id, 'out_id': $routeParams.out_id}).success(function(data, status, headers, config){
                         if (data.status == "ok") {
                           Materialize.toast(data.message, 4000);                   
                           $scope.scan();
                         }else{
                           Materialize.toast(data.message, 4000);
                           $route.reload();
                           $rootScope.preload('no');
                         }
                    });            
                  }
                },1000);
              }, function (err) {
                $scope.scanResult = 'SCAN ERROR (see console)';
                // console.error(err);
              });
          }else{
             Materialize.toast("Stock Cancelled", 4000);
             $route.reload();
          }
        });
      }else{
        $scope.oscpreload = 'reload';
        $cordovaBarcodeScanner
          .scan()
          .then(function (result) {
            $timeout(function(){
              $scope.scanResult = result;
              if(result.cancelled == 1 || result.cancelled == true){
                  $route.reload();
                  $rootScope.preload('no');
              }else{
                $http.post("https://wms-lite.website/function/outgoing_check_item.php",{'were_id': result.text, 'were': $routeParams.were_id, 'out_id': $routeParams.out_id}).success(function(data, status, headers, config){
                     if (data.status == "ok") {
                       Materialize.toast(data.message, 4000);                   
                       $scope.scan();
                     }else{
                       Materialize.toast(data.message, 4000);
                       $route.reload();
                       $rootScope.preload('no');
                     }
                });            
              }
            },1000);
          }, function (err) {
            $scope.scanResult = 'SCAN ERROR (see console)';
            // console.error(err);
          });
      }

    };
    $scope.scanloc = function () {
      $scope.oscpreload = 'reload';
      $scope.action = "Confirm";
      $cordovaDialogs.confirm('Are you sure?', "Stock Out").then(function (buttonIndex) {
        if(buttonIndex == 1){
           $http.post("https://wms-lite.website/function/outgoing_save_item.php",{'were': $routeParams.were_id, 'out_id': $routeParams.out_id}).success(function(data, status, headers, config){
               if (data.status == "ok") {
                 Materialize.toast(data.message, 4000);
                 $route.reload();
                 $rootScope.preload('no');
               }else{
                 Materialize.toast(data.message, 4000);
                 $route.reload();
                 $rootScope.preload('no');
               }
           });
        }else{
           Materialize.toast("Stock Cancelled", 4000);
           $route.reload();
        }
      });
    };

    $scope.save_pick = function () {
      $scope.oscpreload = 'reload';
      $scope.action = "Confirm";
      $cordovaDialogs.confirm('Are you sure?', "Stock Out").then(function (buttonIndex) {
        if(buttonIndex == 1){
           $http.post("https://wms-lite.website/function/outgoing_save_pick_item.php",{'were': $routeParams.were_id, 'out_id': $routeParams.out_id}).success(function(data, status, headers, config){
               if (data.status == "ok") {
                 Materialize.toast(data.message, 4000);
                 $route.reload();
                 $rootScope.preload('no');
               }else{
                 Materialize.toast(data.message, 4000);
                 $route.reload();
                 $rootScope.preload('no');
               }
           });
        }else{
           Materialize.toast("Stock Cancelled", 4000);
           $route.reload();
        }
      });
    };

    $scope.ChangeQty = function(qr_id, packing_qty, process_qty) {
        $http.post("https://wms-lite.website/function/outgoing_change_item.php",{'qr_id': qr_id, 'packing_qty': packing_qty, 'process_qty': process_qty, 'were': $routeParams.were_id}).success(function(data, status, headers, config){
             if (data.status == "ok") {
              //$route.reload();
               Materialize.toast(data.message, 4000);
             }else{
               $route.reload();
               Materialize.toast(data.message, 4000);
             }
        });
    }
    $scope.DeleteQty = function (qr_id) {
      $http.post("https://wms-lite.website/function/outgoing_delete_item.php",{'qr_id': qr_id}).success(function(data, status, headers, config){
           if (data.status == "ok") {
              $route.reload();
           }else{
             Materialize.toast("Network error", 4000);
           }
      });
    }


  }])
 .controller("OutgoingItemCtrl", ["$scope", "$routeParams", "$location", "$route", "$http", "$rootScope", "$timeout", "$cordovaBarcodeScanner", "$cordovaDialogs", function($scope, $routeParams, $location, $route, $http, $rootScope, $timeout, $cordovaBarcodeScanner, $cordovaDialogs){
    $rootScope.var_back = {
        route: "outgoing/"+$routeParams.were_id+"/"+$routeParams.out_id,
        name: "Outgoing"
    };
     $scope.ware = {
        were_id: $routeParams.were_id
    };
    //$routeParams.out_id
    $scope.oscpreload = 'no';
    $rootScope.preload('no');
    $http.post("https://wms-lite.website/function/outgoing_barcode.php",{'were': $routeParams.were_id, 'out_id': $routeParams.out_id, 'qr_id': $routeParams.qr_id}).success(function(data, status, headers, config){
        if (data.status == "ok") {
          $scope.outgoing_data = data;
          $rootScope.preload('no');
        }else{
          Materialize.toast("Network Error", 4000);
        }
    });
    $scope.scan = function () {
      $scope.oscpreload = 'reload';
      $cordovaBarcodeScanner
        .scan()
        .then(function (result) {
          $timeout(function(){
            $scope.scanResult = result;
            if(result.cancelled == 1 || result.cancelled == true){
                $route.reload();
                $rootScope.preload('no');
            }else{
              $http.post("https://wms-lite.website/function/outgoing_barcode_check.php",{'barcode_no': result.text, 'out_id': $routeParams.out_id, 'were': $routeParams.were_id, 'qr_id': $routeParams.qr_id}).success(function(data, status, headers, config){
                   if (data.status == "ok") {
                     Materialize.toast(data.message, 4000);                   
                     $scope.scan();
                   }else{
                     Materialize.toast(data.message, 4000);
                     $route.reload();
                     $rootScope.preload('no');
                   }
              });            
            }
          },1000);
        }, function (err) {
          $scope.scanResult = 'SCAN ERROR (see console)';
          // console.error(err);
        });
    };

    $scope.scan_keyin = function () {
        $scope.action = "Confirm";
        $cordovaDialogs.prompt('Please enter your barcode.', "Stock in").then(function (result) {
          if(result.buttonIndex == 1){
            $http.post("https://wms-lite.website/function/outgoing_barcode_check.php",{'barcode_no': result.input1, 'out_id': $routeParams.out_id, 'were': $routeParams.were_id, 'qr_id': $routeParams.qr_id}).success(function(data, status, headers, config){
              if (data.status == "ok") {
                Materialize.toast(data.message, 4000);
                $scope.scan_keyin();
              }else{
                Materialize.toast(data.message, 4000);
                $route.reload();
                $rootScope.preload('no');
              }
            }); 
          }else{
             Materialize.toast("Barcode enter Cancelled", 4000);
             $route.reload();
             $rootScope.preload('no');             
          }
        });
    };
    $scope.DeleteQty = function (barcode_no) {
      $http.post("https://wms-lite.website/function/outgoing_barcode_delete.php",{'barcode_no': barcode_no}).success(function(data, status, headers, config){
           if (data.status == "ok") {
              $route.reload();
           }else{
              Materialize.toast(data.message, 4000);
           }
      });
    }


  }])
   //##########################################################################//
   //###############          End OutgoingCtrl                       ##########//
   //##########################################################################//
   //##########################################################################//
   //###############          Start ShipList                         ##########//
   //##########################################################################//
 .controller("ShipCtrl", ["$scope", "$routeParams", "$location", "$route", "$http", "$rootScope", "$timeout", "$cordovaBarcodeScanner", "$cordovaDialogs", function($scope, $routeParams, $location, $route, $http, $rootScope, $timeout, $cordovaBarcodeScanner, $cordovaDialogs){
    $rootScope.var_back = {
        route: "operation/"+$routeParams.were_id,
        name: "Operation"
    };
     $scope.ware = {
        were_id: $routeParams.were_id
    };
    //$routeParams.out_id
    $scope.oscpreload = 'no';
    $rootScope.preload('no');
    $http.post("https://wms-lite.website/function/ship.php",{'were': $routeParams.were_id}).success(function(data, status, headers, config){
        if (data.status == "ok") {
          $scope.outgoing_data = data;
          $rootScope.preload('no');
        }else{
          Materialize.toast("Network Error", 4000);
        }
    });

    $scope.scan = function () {
      $scope.oscpreload = 'reload';
      $cordovaBarcodeScanner
        .scan()
        .then(function (result) {
          $timeout(function(){
            $scope.scanResult = result;
            if(result.cancelled == 1 || result.cancelled == true){
                $route.reload();
                $rootScope.preload('no');
            }else{
              $http.post("https://wms-lite.website/function/ship_check.php",{'ship_qr': result.text, 'were': $routeParams.were_id}).success(function(data, status, headers, config){
                   if (data.status == "ok") {
                     Materialize.toast(data.message, 4000);                   
                     $scope.scan();
                   }else{
                     Materialize.toast(data.message, 4000);
                     $route.reload();
                     $rootScope.preload('no');
                   }
              });            
            }
          },1000);
        }, function (err) {
          $scope.scanResult = 'SCAN ERROR (see console)';
          // console.error(err);
        });
    };
    $scope.saveship = function () {
        $http.post("https://wms-lite.website/function/ship_info.php",{'were': $routeParams.were_id, 'ship_company': $scope.outgoing_data.ship.ship_company, 'ship_driver': $scope.outgoing_data.ship.ship_name, 'ship_plate_no': $scope.outgoing_data.ship.ship_plate_no}).success(function(data, status, headers, config){
             if (data.status == "ok") {
               Materialize.toast(data.message, 4000); 
               $route.reload();
               $rootScope.preload('no');
             }else{
               Materialize.toast(data.message, 4000);
               $route.reload();
               $rootScope.preload('no');
             }
        });   
    };
    $scope.scanloc = function () {
      $scope.oscpreload = 'reload';
      $scope.action = "Confirm";
      $cordovaDialogs.confirm('Are you sure?', "Ship Out").then(function (buttonIndex) {
        if(buttonIndex == 1){
           $http.post("https://wms-lite.website/function/ship_save.php",{'were': $routeParams.were_id}).success(function(data, status, headers, config){
               if (data.status == "ok") {
                 Materialize.toast(data.message, 4000);
                 $route.reload();
               }else{
                 Materialize.toast(data.message, 4000);
                 $route.reload();
               }
           });
        }else{
           Materialize.toast("Ship Cancelled", 4000);
           $route.reload();
        }
      });
    };

    $scope.DeleteQty = function (ship_qr) {
      $http.post("https://wms-lite.website/function/ship_delete.php",{'ship_qr': ship_qr}).success(function(data, status, headers, config){
           if (data.status == "ok") {
              $route.reload();
              Materialize.toast(data.message, 4000);
           }else{
              Materialize.toast(data.message, 4000);
           }
      });
    }


  }])
   //##########################################################################//
   //###############          End ShipListCtrl                       ##########//
   //##########################################################################//
   //##########################################################################//
   //###############          Start TransferCtrl                     ##########//
   //##########################################################################//
  .controller("TransferInOut", ["$scope", "$routeParams", "$location", "$route", "$http", "$rootScope", "$timeout", function($scope, $routeParams, $location, $route, $http, $rootScope, $timeout){
    $rootScope.var_back = {
        route: "transfer/"+$routeParams.were_id,
        name: "Transfer Operation"
    };
     $scope.were = {
        were_id: $routeParams.were_id
    };
    $scope.oscpreload = 'no';
    $rootScope.preload('no');
    $http.post("https://wms-lite.website/function/transfer_job_list.php",{'were': $routeParams.were_id}).success(function(data, status, headers, config){
        if (data.status == "ok") {
         $scope.transfer_job_date = data;
         $rootScope.preload('no');
        }else{
          Materialize.toast("Network Error", 4000);
        }
    });

 }])
.controller("TransferOutJobCtrl", ["$scope", "$routeParams", "$location", "$route", "$http", "$rootScope", "$timeout", function($scope, $routeParams, $location, $route, $http, $rootScope, $timeout){
    $rootScope.var_back = {
        route: "transfer/"+$routeParams.were_id,
        name: "Transfer Operation"
    };
    $scope.wereid = $routeParams.were_id;
    $scope.oscpreload = 'no';
    $rootScope.preload('no');
    $http.post("https://wms-lite.website/function/transfer_job_list.php",{'were': $routeParams.were_id}).success(function(data, status, headers, config){
        if (data.status == "ok") {
         $scope.trans_out_job_data = data;
         $rootScope.preload('no');
        }else{
          Materialize.toast("Network Error", 4000);
        }
    });

 }])
 .controller("TransferExternalOutCtrl", ["$scope", "$routeParams", "$location", "$route", "$http", "$rootScope", "$timeout", "$cordovaBarcodeScanner", "$cordovaDialogs", function($scope, $routeParams, $location, $route, $http, $rootScope, $timeout, $cordovaBarcodeScanner, $cordovaDialogs){
    $rootScope.var_back = {
        route: "transfer_external/"+$routeParams.were_id,
        name: "Transfer External"
    };
    $scope.wereid = $routeParams.were_id;
    $scope.trans_id = $routeParams.trans_id;
    //$routeParams.out_id
    $scope.oscpreload = 'no';
    $rootScope.preload('no');
    $http.post("https://wms-lite.website/function/transfer_external_out_list.php",{'were': $routeParams.were_id, 'trans_id': $routeParams.trans_id}).success(function(data, status, headers, config){
        if (data.status == "ok") {
          $scope.transfer_data = data;
          $rootScope.preload('no');
        }else{
          Materialize.toast("Network Error", 4000);
        }
    });
    $scope.scan = function () {
      $scope.oscpreload = 'reload';
      $cordovaBarcodeScanner
        .scan()
        .then(function (result) {
          $timeout(function(){
            $scope.scanResult = result;
            if(result.cancelled == 1 || result.cancelled == true){
                $route.reload();
                $rootScope.preload('no');
            }else{
              $http.post("https://wms-lite.website/function/transfer_external_out_check.php",{'were_id': result.text, 'were': $routeParams.were_id, 'trans_id': $routeParams.trans_id}).success(function(data, status, headers, config){
                   if (data.status == "ok") {
                     Materialize.toast(data.message, 4000);
                     //$route.reload();
                     //$rootScope.preload('no');
                     $scope.scan();
                   }else{
                     Materialize.toast(data.message, 4000);
                     $route.reload();
                     $rootScope.preload('no');
                   }
              });
              
            }
          },1000);
        }, function (err) {
          $scope.scanResult = 'SCAN ERROR (see console)';
          // console.error(err);
        });
    };
    $scope.scanloc = function () {
      $scope.oscpreload = 'reload';
      $scope.action = "Confirm";
      $cordovaDialogs.confirm('Are you sure?', "Transfer Out?").then(function (buttonIndex) {
        if(buttonIndex == 1){
           $http.post("https://wms-lite.website/function/transfer_save_item.php",{'were': $routeParams.were_id, 'trans_id': $routeParams.trans_id}).success(function(data, status, headers, config){
               if (data.status == "ok") {
                 Materialize.toast(data.message, 4000);
                 $route.reload();
               }else{
                 Materialize.toast(data.message, 4000);
                 $route.reload();
               }
           });
        }else{
           Materialize.toast("Stock Cancelled", 4000);
           $route.reload();
        }
      });
    };

    $scope.DeleteQty = function (qr_id) {
      $http.post("https://wms-lite.website/function/transfer_delete_item.php",{'qr_id': qr_id}).success(function(data, status, headers, config){
           if (data.status == "ok") {
              $route.reload();
           }else{
             Materialize.toast("Network error", 4000);
             $route.reload();
           }
      });
    }
    $scope.confirm_out = function () {
      $scope.oscpreload = 'reload';
      $scope.action = "Confirm";
      $cordovaDialogs.confirm('Confirm Transfer Out?', "Confirm Transfer Out?").then(function (buttonIndex) {
        if(buttonIndex == 1){
          $http.post("https://wms-lite.website/function/transfer_external_confirm.php",{'trans_id': $routeParams.trans_id}).success(function(data, status, headers, config){
               if (data.status == "ok") {
                  Materialize.toast(data.message, 4000);
                  $location.path('transfer_external/'+$routeParams.were_id);
                  // $route.reload();
               }else{
                 Materialize.toast("Network error", 4000);
                 $route.reload();
               }
          });
        }else{
           Materialize.toast("Stock Cancelled", 4000);
           $route.reload();
        }
      });

    }
  }])
 .controller("TransferOutCtrl", ["$scope", "$routeParams", "$location", "$route", "$http", "$rootScope", "$timeout", "$cordovaBarcodeScanner", "$cordovaDialogs", function($scope, $routeParams, $location, $route, $http, $rootScope, $timeout, $cordovaBarcodeScanner, $cordovaDialogs){
    $rootScope.var_back = {
        route: "operation/"+$routeParams.were_id,
        name: "Operation"
    };
    $scope.wereid = $routeParams.were_id;
    $scope.trans_id = $routeParams.trans_id;
    //$routeParams.out_id
    $scope.oscpreload = 'no';
    $rootScope.preload('no');
    $http.post("https://wms-lite.website/function/transfer_out_list.php",{'were': $routeParams.were_id, 'trans_id': $routeParams.trans_id}).success(function(data, status, headers, config){
        if (data.status == "ok") {
          $scope.transfer_data = data;
          $rootScope.preload('no');
        }else{
          Materialize.toast("Network Error", 4000);
        }
    });
    $scope.scan = function () {
      $scope.oscpreload = 'reload';
      $cordovaBarcodeScanner
        .scan()
        .then(function (result) {
          $timeout(function(){
            $scope.scanResult = result;
            if(result.cancelled == 1 || result.cancelled == true){
                $route.reload();
                $rootScope.preload('no');
            }else{
              $http.post("https://wms-lite.website/function/transfer_check_item.php",{'were_id': result.text, 'were': $routeParams.were_id, 'trans_id': $routeParams.trans_id}).success(function(data, status, headers, config){
                   if (data.status == "ok") {
                     Materialize.toast(data.message, 4000);
                     //$route.reload();
                     //$rootScope.preload('no');
                     $scope.scan();
                   }else{
                     Materialize.toast(data.message, 4000);
                     $route.reload();
                     $rootScope.preload('no');
                   }
              });
              
            }
          },1000);
        }, function (err) {
          $scope.scanResult = 'SCAN ERROR (see console)';
          // console.error(err);
        });
    };
    $scope.scanloc = function () {
      $scope.oscpreload = 'reload';
      $scope.action = "Confirm";
      $cordovaDialogs.confirm('Are you sure?', "Transfer Out?").then(function (buttonIndex) {
        if(buttonIndex == 1){
           $http.post("https://wms-lite.website/function/transfer_save_item.php",{'were': $routeParams.were_id, 'trans_id': $routeParams.trans_id}).success(function(data, status, headers, config){
               if (data.status == "ok") {
                 Materialize.toast(data.message, 4000);
                 $route.reload();
               }else{
                 Materialize.toast(data.message, 4000);
                 $route.reload();
               }
           });
        }else{
           Materialize.toast("Stock Cancelled", 4000);
           $route.reload();
        }
      });
    };

    $scope.DeleteQty = function (qr_id) {
      $http.post("https://wms-lite.website/function/transfer_delete_item.php",{'qr_id': qr_id}).success(function(data, status, headers, config){
           if (data.status == "ok") {
              $route.reload();
           }else{
             Materialize.toast("Network error", 4000);
             $route.reload();
           }
      });
    }
    $scope.confirm_out = function () {
      $scope.oscpreload = 'reload';
      $scope.action = "Confirm";
      $cordovaDialogs.confirm('Confirm Transfer Out?', "Confirm Transfer Out?").then(function (buttonIndex) {
        if(buttonIndex == 1){
           $http.post("https://wms-lite.website/function/transfer_save_item.php",{'were': $routeParams.were_id, 'trans_id': $routeParams.trans_id}).success(function(data, status, headers, config){
               if (data.status == "ok") {
                 Materialize.toast(data.message, 4000);
               }else{
                 Materialize.toast(data.message, 4000);
               }
           });
          $http.post("https://wms-lite.website/function/transfer_confirm.php",{'trans_id': $routeParams.trans_id}).success(function(data, status, headers, config){
               if (data.status == "ok") {
                  Materialize.toast(data.message, 4000);
                  $location.path('transfer_internal/'+$routeParams.were_id);
                  // $route.reload();
               }else{
                 Materialize.toast("Network error", 4000);
                 $route.reload();
               }
          });
        }else{
           Materialize.toast("Stock Cancelled", 4000);
           $route.reload();
        }
      });

    }
  }])
  .controller("TransferJobCtrl", ["$scope", "$routeParams", "$location", "$route", "$http", "$rootScope", "$timeout", function($scope, $routeParams, $location, $route, $http, $rootScope, $timeout){
    $rootScope.var_back = {
        route: "operation/"+$routeParams.were_id,
        name: "Operation"
    };
    $scope.wereid = $routeParams.were_id;
    $scope.oscpreload = 'no';
    $rootScope.preload('no');
    $http.post("https://wms-lite.website/function/transfer_job_list.php",{'were': $routeParams.were_id}).success(function(data, status, headers, config){
        if (data.status == "ok") {
         $scope.trans_job_data = data;
         $rootScope.preload('no');
        }else{
          Materialize.toast("Network Error", 4000);
        }
    });

 }])  
  .controller("TransferInCtrl", ["$scope", "$routeParams", "$location", "$route", "$http", "$rootScope", "$timeout", "$cordovaBarcodeScanner", "$cordovaDialogs", function($scope, $routeParams, $location, $route, $http, $rootScope, $timeout, $cordovaBarcodeScanner, $cordovaDialogs){
    $rootScope.var_back = {
        route: "operation/"+$routeParams.were_id,
        name: "Operation"
    };
    $scope.wereid = $routeParams.were_id;
    //$routeParams.out_id
    $scope.oscpreload = 'no';
    $rootScope.preload('no');
    $http.post("https://wms-lite.website/function/transfer_in_list.php",{'were': $routeParams.were_id, 'trans_id': $routeParams.trans_id}).success(function(data, status, headers, config){
        if (data.status == "ok") {
          $scope.transfer_in_data = data;
          $rootScope.preload('no');
        }else{
          Materialize.toast("Network Error", 4000);
        }
    });
    $scope.scan = function () {
      $scope.oscpreload = 'reload';
      $cordovaBarcodeScanner
        .scan()
        .then(function (result) {
          $timeout(function(){
            $scope.scanResult = result;
            if(result.cancelled == 1 || result.cancelled == true){
                $route.reload();
                $rootScope.preload('no');
            }else{
              $http.post("https://wms-lite.website/function/transfer_in_check_item.php",{'were_id': result.text, 'were': $routeParams.were_id, 'trans_id': $routeParams.trans_id}).success(function(data, status, headers, config){
                   if (data.status == "ok") {
                     Materialize.toast(data.message, 10000);
                     //$route.reload();
                     //$rootScope.preload('no');
                     $scope.scan();
                   }else{
                     Materialize.toast(data.message, 4000);
                     $route.reload();
                     $rootScope.preload('no');
                   }
              });
              
            }
          },1000);
        }, function (err) {
          $scope.scanResult = 'SCAN ERROR (see console)';
          // console.error(err);
        });
    };
    $scope.scanloc = function () {
      $scope.iscpreload = 'reload';
      $cordovaBarcodeScanner
        .scan()
        .then(function (result) {
          $timeout(function(){
            $scope.scanResult = result;
            if(result.cancelled == 1 || result.cancelled == true){

            }else{
              $rootScope.preload('no');
             

                    $scope.action = "Confirm";
                    $cordovaDialogs.confirm('Are you sure?', "Transfer In").then(function (buttonIndex) {
                      if(buttonIndex == 1){
                         $http.post("https://wms-lite.website/function/transfer_in_save_item.php",{'loc_id': result.text, 'were': $routeParams.were_id, 'trans_id': $routeParams.trans_id}).success(function(data, status, headers, config){
                             if (data.status == "ok") {
                               Materialize.toast(data.message, 4000);
                               $location.path('transfer_internal/'+$routeParams.were_id);
                             }else{
                               Materialize.toast(data.message, 4000);
                             }
                         });
                      }else{
                         Materialize.toast("Stock Cancelled", 4000);
                         $route.reload();
                      }
                    });                 
            }
          },1000);
        }, function (err) {
          $scope.scanResult = 'SCAN ERROR (see console)';
          // console.error(err);
        });
    };

    $scope.DeleteQty = function (qr_id) {
      $http.post("https://wms-lite.website/function/transfer_in_delete_item.php",{'qr_id': qr_id}).success(function(data, status, headers, config){
           if (data.status == "ok") {
              $route.reload();
           }else{
             Materialize.toast("Network error", 4000);
           }
      });
    }
    $scope.revert_out = function () {
      $scope.oscpreload = 'reload';
      $scope.action = "Confirm";
      $cordovaDialogs.confirm('Confirm Revert to Transfer?', "Confirm Revert to Transfer?").then(function (buttonIndex) {
        if(buttonIndex == 1){
          $http.post("https://wms-lite.website/function/transfer_confirm_revert.php",{'trans_id': $routeParams.trans_id}).success(function(data, status, headers, config){
               if (data.status == "ok") {
                  Materialize.toast(data.message, 4000);
                  $location.path('transfer_internal/'+$routeParams.were_id);
                  // $route.reload();
               }else{
                 Materialize.toast("Network error", 4000);
                 $route.reload();
               }
          });
        }else{
           Materialize.toast("Stock Cancelled", 4000);
           $route.reload();
        }
      });

    }
  }])
   //##########################################################################//
   //###############          End TransferCtrl                       ##########//
   //##########################################################################//
   //###############          Start operationCtrl                    ##########//
   //##########################################################################//
  .controller("TransferExternalInCtrl", ["$scope", "$routeParams", "$location", "$route", "$http", "$rootScope", "$timeout", "$cordovaBarcodeScanner", "$cordovaDialogs", function($scope, $routeParams, $location, $route, $http, $rootScope, $timeout, $cordovaBarcodeScanner, $cordovaDialogs){
    $rootScope.var_back = {
        route: "transfer_external/"+$routeParams.were_id,
        name: "Transfer External"
    };
    $scope.wereid = $routeParams.were_id;
    //$routeParams.out_id
    $scope.oscpreload = 'no';
    $rootScope.preload('no');
    $http.post("https://wms-lite.website/function/transfer_external_in_list.php",{'were': $routeParams.were_id, 'trans_id': $routeParams.trans_id}).success(function(data, status, headers, config){
        if (data.status == "ok") {
          $scope.transfer_in_data = data;
          $rootScope.preload('no');
        }else{
          Materialize.toast("Network Error", 4000);
        }
    });
    $scope.scan = function () {
      $scope.oscpreload = 'reload';
      $cordovaBarcodeScanner
        .scan()
        .then(function (result) {
          $timeout(function(){
            $scope.scanResult = result;
            if(result.cancelled == 1 || result.cancelled == true){
                $route.reload();
                $rootScope.preload('no');
            }else{
              $http.post("https://wms-lite.website/function/transfer_external_in_check.php",{'were_id': result.text, 'were': $routeParams.were_id, 'trans_id': $routeParams.trans_id}).success(function(data, status, headers, config){
                   if (data.status == "ok") {
                     Materialize.toast(data.message, 4000);
                     //$route.reload();
                     //$rootScope.preload('no');
                     $scope.scan();
                   }else{
                     Materialize.toast(data.message, 4000);
                     $route.reload();
                     $rootScope.preload('no');
                   }
              });
              
            }
          },1000);
        }, function (err) {
          $scope.scanResult = 'SCAN ERROR (see console)';
          // console.error(err);
        });
    };
    $scope.scanloc = function () {
      $scope.iscpreload = 'reload';
      $cordovaBarcodeScanner
        .scan()
        .then(function (result) {
          $timeout(function(){
            $scope.scanResult = result;
            if(result.cancelled == 1 || result.cancelled == true){

            }else{
              $rootScope.preload('no');
             

                    $scope.action = "Confirm";
                    $cordovaDialogs.confirm('Are you sure?', "Transfer In").then(function (buttonIndex) {
                      if(buttonIndex == 1){
                         $http.post("https://wms-lite.website/function/transfer_in_save_item.php",{'loc_id': result.text, 'were': $routeParams.were_id, 'trans_id': $routeParams.trans_id}).success(function(data, status, headers, config){
                             if (data.status == "ok") {
                               Materialize.toast(data.message, 4000);
                               $location.path('transfer_external/'+$routeParams.were_id);
                             }else{
                               Materialize.toast(data.message, 4000);
                             }
                         });
                      }else{
                         Materialize.toast("Stock Cancelled", 4000);
                         $route.reload();
                      }
                    });                 
            }
          },1000);
        }, function (err) {
          $scope.scanResult = 'SCAN ERROR (see console)';
          // console.error(err);
        });
    };

    $scope.DeleteQty = function (qr_id) {
      $http.post("https://wms-lite.website/function/transfer_in_delete_item.php",{'qr_id': qr_id}).success(function(data, status, headers, config){
           if (data.status == "ok") {
              $route.reload();
           }else{
             Materialize.toast("Network error", 4000);
           }
      });
    }
    $scope.revert_out = function () {
      $scope.oscpreload = 'reload';
      $scope.action = "Confirm";
      $cordovaDialogs.confirm('Confirm Revert to Transfer?', "Confirm Revert to Transfer?").then(function (buttonIndex) {
        if(buttonIndex == 1){
          $http.post("https://wms-lite.website/function/transfer_external_confirm_revert.php",{'trans_id': $routeParams.trans_id}).success(function(data, status, headers, config){
               if (data.status == "ok") {
                  Materialize.toast(data.message, 4000);
                  $location.path('transfer_external/'+$routeParams.were_id);
                  // $route.reload();
               }else{
                 Materialize.toast("Network error", 4000);
                 $route.reload();
               }
          });
        }else{
           Materialize.toast("Stock Cancelled", 4000);
           $route.reload();
        }
      });

    }
  }])
   //##########################################################################//
   //###############          End TransferCtrl                       ##########//
   //##########################################################################//
   //###############          Start operationCtrl                    ##########//
   //##########################################################################//

 .controller("operationCtrl", ["$scope", "$routeParams", "$location", "$route", "$http", "$rootScope", "$timeout", function($scope, $routeParams, $location, $route, $http, $rootScope, $timeout){
    $rootScope.var_back = {
        route: "home",
        name: "Warehouse"
    };

     $http.get('https://wms-lite.website/function/home.php').success(function(data) {
        if (data.status == "ok") {
          $scope.warehouse = data;
            if(data.num > 1){
              $rootScope.var_back = {
                  route: "home",
                  name: "Warehouse"
              };
            }else{
              $rootScope.var_back = {
                  route: "logout",
                  name: "Logout"
              };
            }
        }else{
        }
     });

    $http.post("https://wms-lite.website/function/operation.php",{'were_id': $routeParams.were_id}).success(function(data, status, headers, config){
        if (data.status == "ok") {
          $scope.ware = data;
          $rootScope.preset_ware = data;
          $rootScope.preload('no');
        }else{
          Materialize.toast("Network Error", 4000);
        }
   });
  }])
   //##########################################################################//
   //###############          End operationCtrl                      ##########//
   //##########################################################################//
   //###############          Start TransferExternalCtrl             ##########//
   //##########################################################################//
  .controller("TransferExternalCtrl", ["$scope", "$routeParams", "$location", "$route", "$http", "$rootScope", "$timeout", function($scope, $routeParams, $location, $route, $http, $rootScope, $timeout){
      $rootScope.var_back = {
          route: "transfer/"+$routeParams.were_id,
          name: "Transfer"
      };
      $scope.wereid = $routeParams.were_id;
      $scope.oscpreload = 'no';
      $rootScope.preload('no');
      $http.post("https://wms-lite.website/function/transfer_external_list.php",{'were': $routeParams.were_id}).success(function(data, status, headers, config){
          if (data.status == "ok") {
           $scope.trans_out_job_data = data;
           $rootScope.preload('no');
          }else{
            Materialize.toast("Network Error", 4000);
          }
      });

   }])
   //##########################################################################//
   //###############          End TransferExternalCtrl		           ##########//
   //##########################################################################//
   //###############          Start transferoperationCtrl            ##########//
   //##########################################################################//

 .controller("transferoperationCtrl", ["$scope", "$routeParams", "$location", "$route", "$http", "$rootScope", "$timeout", function($scope, $routeParams, $location, $route, $http, $rootScope, $timeout){
    $rootScope.var_back = {
        route: "operation/"+$routeParams.were_id,
        name: "Operation"
    };

     $http.get('https://wms-lite.website/function/home.php').success(function(data) {
        if (data.status == "ok") {
          $scope.warehouse = data;
            if(data.num > 1){
              $rootScope.var_back = {
                  route: "operation/"+$routeParams.were_id,
                  name: "Operation"
              };
            }else{
              $rootScope.var_back = {
                  route: "logout",
                  name: "Logout"
              };
            }
        }else{
        }
     });

    $http.post("https://wms-lite.website/function/operation.php",{'were_id': $routeParams.were_id}).success(function(data, status, headers, config){
        if (data.status == "ok") {
          $scope.ware = data;
          $rootScope.preload('no');
        }else{
          Materialize.toast("Network Error", 4000);
        }
   });
  }])
   //##########################################################################//
   //###############          End operationCtrl                      ##########//
   //##########################################################################//
   //##########################################################################//
   //###############          Start InfoCtrl                         ##########//
   //##########################################################################//
 .controller("InfoCtrl", ["$scope", "$routeParams", "$location", "$route", "$http", "$rootScope", "$timeout", "$cordovaBarcodeScanner", "$cordovaDialogs", function($scope, $routeParams, $location, $route, $http, $rootScope, $timeout, $cordovaBarcodeScanner, $cordovaDialogs){
    $rootScope.var_back = {
        route: "operation/"+$routeParams.were_id,
        name: "Operation"
    };
    $scope.iscpreload = 'no';
    $rootScope.preload('no');  
    //scan item
    $scope.scan = function () {
      $scope.iscpreload = 'reload';
      $cordovaBarcodeScanner
        .scan()
        .then(function (result) {
          $timeout(function(){
            $scope.scanResult = result;
            if(result.cancelled == 1 || result.cancelled == true){
                $route.reload();
                $rootScope.preload('no');
            }else{
              $http.post("https://wms-lite.website/function/info.php",{'qr_no': result.text, 'were': $routeParams.were_id}).success(function(data, status, headers, config){           
                   if (data.status == "ok") {
                     $rootScope.preload('no');
                     Materialize.toast(data.message, 4000);
                      $scope.iscpreload = 'no';
                      $rootScope.preload('no');  
                     $scope.scan_return = data;
                   }else{
                     Materialize.toast(data.message, 4000);
                     $route.reload();
                     $rootScope.preload('no');
                   }
              });  
            }
          },1000);
        }, function (err) {
          $scope.scanResult = 'SCAN ERROR (see console)';
          // console.error(err);
        },
        {
          preferFrontCamera : true,
          showFlipCameraButton : true,
          formats : "QR_CODE, RSS_EXPANDED",
          prompt: "Place a barcode inside the scan area",    //if I remove this line, the prompt shows the result the same way
          orientation : "portrait"
        }
    );
    };

  }])
   //##########################################################################//
   //###############          End IncomingCtrl                       ##########//
   //##########################################################################//
   //###############          Start DashboardCtrl                    ##########//
   //##########################################################################//
  .controller("DashboardCtrl", ["$scope", "$routeParams", "$location", "$route", "$http", "$rootScope", "$timeout", function($scope, $routeParams, $location, $route, $http, $rootScope, $timeout){
	   $rootScope.preload('no');
  }]);
   //##########################################################################//
   //###############          End MainControl                        ##########//
   //##########################################################################//